--- /home/monnier/work/xemacs/src/regex.c	Thu Dec 14 17:15:15 2000
+++ src/regex.c.1.138	Thu Apr 26 09:32:57 2001
@@ -645,18 +797,18 @@
       if (fastmap[i++])
 	{
 	  was_a_range = 0;
-          putchar (i - 1);
-          while (i < (1 << BYTEWIDTH)  &&  fastmap[i])
-            {
-              was_a_range = 1;
-              i++;
-            }
+	  putchar (i - 1);
+	  while (i < (1 << BYTEWIDTH)  &&  fastmap[i])
+	    {
+	      was_a_range = 1;
+	      i++;
+	    }
 	  if (was_a_range)
-            {
-              putchar ('-');
-              putchar (i - 1);
-            }
-        }
+	    {
+	      printf ("-");
+	      putchar (i - 1);
+	    }
+	}
     }
   putchar ('\n');
 }
@@ -665,50 +817,52 @@
 /* Print a compiled pattern string in human-readable form, starting at
    the START pointer into it and ending just before the pointer END.  */
 
-static void
-print_partial_compiled_pattern (re_char *start, re_char *end)
+void
+print_partial_compiled_pattern (start, end)
+    unsigned char *start;
+    unsigned char *end;
 {
   int mcnt, mcnt2;
-  unsigned char *p = (unsigned char *) start;
-  re_char *pend = end;
+  unsigned char *p = start;
+  unsigned char *pend = end;
 
   if (start == NULL)
     {
-      puts ("(null)");
+      printf ("(null)\n");
       return;
     }
 
   /* Loop over pattern commands.  */
   while (p < pend)
     {
-      printf ("%ld:\t", (long)(p - start));
+      printf ("%d:\t", p - start);
 
       switch ((re_opcode_t) *p++)
 	{
-        case no_op:
-          printf ("/no_op");
-          break;
+	case no_op:
+	  printf ("/no_op");
+	  break;
 
 	case exactn:
 	  mcnt = *p++;
-          printf ("/exactn/%d", mcnt);
-          do
+	  printf ("/exactn/%d", mcnt);
+	  do
 	    {
-              putchar ('/');
+	      putchar ('/');
 	      putchar (*p++);
-            }
-          while (--mcnt);
-          break;
+	    }
+	  while (--mcnt);
+	  break;
 
 	case start_memory:
-          mcnt = *p++;
-          printf ("/start_memory/%d/%d", mcnt, *p++);
-          break;
+	  mcnt = *p++;
+	  printf ("/start_memory/%d/%d", mcnt, *p++);
+	  break;
 
 	case stop_memory:
-          mcnt = *p++;
+	  mcnt = *p++;
 	  printf ("/stop_memory/%d/%d", mcnt, *p++);
-          break;
+	  break;
 
 	case duplicate:
 	  printf ("/duplicate/%d", *p++);
@@ -719,18 +873,21 @@
 	  break;
 
 	case charset:
-        case charset_not:
-          {
-            REGISTER int c, last = -100;
-	    REGISTER int in_range = 0;
+	case charset_not:
+	  {
+	    register int c, last = -100;
+	    register int in_range = 0;
+	    int length = *p & 0x7f;
+	    int has_range_table = *p & 0x80;
+	    int range_length = p[length + 2] + p[length + 3] * 0x100;
 
 	    printf ("/charset [%s",
-	            (re_opcode_t) *(p - 1) == charset_not ? "^" : "");
+		    (re_opcode_t) *(p - 1) == charset_not ? "^" : "");
 
-            assert (p + *p < pend);
+	    assert (p + *p < pend);
 
-            for (c = 0; c < 256; c++)
-	      if (((unsigned char) (c / 8) < *p)
+	    for (c = 0; c < 256; c++)
+	      if (c / 8 < length
 		  && (p[1 + (c/8)] & (1 << (c % 8))))
 		{
 		  /* Are we starting a range?  */
@@ -750,124 +907,97 @@
 		    putchar (c);
 
 		  last = c;
-              }
+	      }
+
+	    p += 1 + length;
 
 	    if (in_range)
 	      putchar (last);
 
 	    putchar (']');
 
-	    p += 1 + *p;
-	  }
-	  break;
-
-#ifdef MULE
-	case charset_mule:
-        case charset_mule_not:
-          {
-	    int nentries, i;
-
-	    printf ("/charset_mule [%s",
-	            (re_opcode_t) *(p - 1) == charset_mule_not ? "^" : "");
-	    nentries = unified_range_table_nentries (p);
-	    for (i = 0; i < nentries; i++)
-	      {
-		EMACS_INT first, last;
-		Lisp_Object dummy_val;
+	    if (has_range_table)
+	      printf ("has-range-table");
 
-		unified_range_table_get_range (p, i, &first, &last,
-					       &dummy_val);
-		if (first < 0x100)
-		  putchar (first);
-		else
-		  printf ("(0x%lx)", (long)first);
-		if (first != last)
-		  {
-		    putchar ('-');
-		    if (last < 0x100)
-		      putchar (last);
-		    else
-		      printf ("(0x%lx)", (long)last);
-		  }
-	      }
-	    putchar (']');
-	    p += unified_range_table_bytes_used (p);
+	    /* ??? Should print the range table; for now,
+	       just skip it.  */
+	    if (has_range_table)
+	      p += 4 + 6 * range_length;
 	  }
 	  break;
-#endif
 
 	case begline:
 	  printf ("/begline");
-          break;
+	  break;
 
 	case endline:
-          printf ("/endline");
-          break;
+	  printf ("/endline");
+	  break;
 
 	case on_failure_jump:
-          extract_number_and_incr (&mcnt, &p);
-  	  printf ("/on_failure_jump to %ld", (long)(p + mcnt - start));
-          break;
+	  extract_number_and_incr (&mcnt, &p);
+	  printf ("/on_failure_jump to %d", p + mcnt - start);
+	  break;
 
 	case on_failure_keep_string_jump:
-          extract_number_and_incr (&mcnt, &p);
-  	  printf ("/on_failure_keep_string_jump to %ld", (long)(p + mcnt - start));
-          break;
+	  extract_number_and_incr (&mcnt, &p);
+	  printf ("/on_failure_keep_string_jump to %d", p + mcnt - start);
+	  break;
 
 	case dummy_failure_jump:
-          extract_number_and_incr (&mcnt, &p);
-  	  printf ("/dummy_failure_jump to %ld", (long)(p + mcnt - start));
-          break;
+	  extract_number_and_incr (&mcnt, &p);
+	  printf ("/dummy_failure_jump to %d", p + mcnt - start);
+	  break;
 
 	case push_dummy_failure:
-          printf ("/push_dummy_failure");
-          break;
+	  printf ("/push_dummy_failure");
+	  break;
 
-        case maybe_pop_jump:
-          extract_number_and_incr (&mcnt, &p);
-  	  printf ("/maybe_pop_jump to %ld", (long)(p + mcnt - start));
+	case maybe_pop_jump:
+	  extract_number_and_incr (&mcnt, &p);
+	  printf ("/maybe_pop_jump to %d", p + mcnt - start);
 	  break;
 
-        case pop_failure_jump:
+	case pop_failure_jump:
 	  extract_number_and_incr (&mcnt, &p);
-  	  printf ("/pop_failure_jump to %ld", (long)(p + mcnt - start));
+	  printf ("/pop_failure_jump to %d", p + mcnt - start);
 	  break;
 
-        case jump_past_alt:
+	case jump_past_alt:
 	  extract_number_and_incr (&mcnt, &p);
-  	  printf ("/jump_past_alt to %ld", (long)(p + mcnt - start));
+	  printf ("/jump_past_alt to %d", p + mcnt - start);
 	  break;
 
-        case jump:
+	case jump:
 	  extract_number_and_incr (&mcnt, &p);
-  	  printf ("/jump to %ld", (long)(p + mcnt - start));
+	  printf ("/jump to %d", p + mcnt - start);
 	  break;
 
-        case succeed_n:
-          extract_number_and_incr (&mcnt, &p);
-          extract_number_and_incr (&mcnt2, &p);
-	  printf ("/succeed_n to %ld, %d times", (long)(p + mcnt - start), mcnt2);
-          break;
+	case succeed_n:
+	  extract_number_and_incr (&mcnt, &p);
+	  extract_number_and_incr (&mcnt2, &p);
+	  printf ("/succeed_n to %d, %d times", p + mcnt - start, mcnt2);
+	  break;
 
-        case jump_n:
-          extract_number_and_incr (&mcnt, &p);
-          extract_number_and_incr (&mcnt2, &p);
-	  printf ("/jump_n to %ld, %d times", (long)(p + mcnt - start), mcnt2);
-          break;
+	case jump_n:
+	  extract_number_and_incr (&mcnt, &p);
+	  extract_number_and_incr (&mcnt2, &p);
+	  printf ("/jump_n to %d, %d times", p + mcnt - start, mcnt2);
+	  break;
 
-        case set_number_at:
-          extract_number_and_incr (&mcnt, &p);
-          extract_number_and_incr (&mcnt2, &p);
-	  printf ("/set_number_at location %ld to %d", (long)(p + mcnt - start), mcnt2);
-          break;
+	case set_number_at:
+	  extract_number_and_incr (&mcnt, &p);
+	  extract_number_and_incr (&mcnt2, &p);
+	  printf ("/set_number_at location %d to %d", p + mcnt - start, mcnt2);
+	  break;
 
-        case wordbound:
+	case wordbound:
 	  printf ("/wordbound");
 	  break;
 
 	case notwordbound:
 	  printf ("/notwordbound");
-          break;
+	  break;
 
 	case wordbeg:
 	  printf ("/wordbeg");
@@ -879,80 +1009,64 @@
 #ifdef emacs
 	case before_dot:
 	  printf ("/before_dot");
-          break;
+	  break;
 
 	case at_dot:
 	  printf ("/at_dot");
-          break;
+	  break;
 
 	case after_dot:
 	  printf ("/after_dot");
-          break;
-
-	case syntaxspec:
-          printf ("/syntaxspec");
-	  mcnt = *p++;
-	  printf ("/%d", mcnt);
-          break;
-
-	case notsyntaxspec:
-          printf ("/notsyntaxspec");
-	  mcnt = *p++;
-	  printf ("/%d", mcnt);
 	  break;
 
-#ifdef MULE
-/* 97/2/17 jhod Mule category patch */
-	case categoryspec:
-	  printf ("/categoryspec");
+	case syntaxspec:
+	  printf ("/syntaxspec");
 	  mcnt = *p++;
 	  printf ("/%d", mcnt);
 	  break;
 
-	case notcategoryspec:
-	  printf ("/notcategoryspec");
+	case notsyntaxspec:
+	  printf ("/notsyntaxspec");
 	  mcnt = *p++;
 	  printf ("/%d", mcnt);
 	  break;
-/* end of category patch */
-#endif /* MULE */
 #endif /* emacs */
 
 	case wordchar:
 	  printf ("/wordchar");
-          break;
+	  break;
 
 	case notwordchar:
 	  printf ("/notwordchar");
-          break;
+	  break;
 
 	case begbuf:
 	  printf ("/begbuf");
-          break;
+	  break;
 
 	case endbuf:
 	  printf ("/endbuf");
-          break;
+	  break;
 
-        default:
-          printf ("?%d", *(p-1));
+	default:
+	  printf ("?%d", *(p-1));
 	}
 
       putchar ('\n');
     }
 
-  printf ("%ld:\tend of pattern.\n", (long)(p - start));
+  printf ("%d:\tend of pattern.\n", p - start);
 }
 
 
-static void
-print_compiled_pattern (struct re_pattern_buffer *bufp)
+void
+print_compiled_pattern (bufp)
+    struct re_pattern_buffer *bufp;
 {
-  re_char *buffer = bufp->buffer;
+  unsigned char *buffer = bufp->buffer;
 
   print_partial_compiled_pattern (buffer, buffer + bufp->used);
-  printf ("%ld bytes used/%ld bytes allocated.\n", bufp->used,
-	  bufp->allocated);
+  printf ("%d bytes used/%d bytes allocated.\n", bufp->used, bufp->allocated);
 
   if (bufp->fastmap_accurate && bufp->fastmap)
     {
@@ -960,7 +1074,7 @@
       print_fastmap (bufp->fastmap);
     }
 
-  printf ("re_nsub: %ld\t", (long)bufp->re_nsub);
+  printf ("re_nsub: %d\t", bufp->re_nsub);
   printf ("regs_alloc: %d\t", bufp->regs_allocated);
   printf ("can_be_null: %d\t", bufp->can_be_null);
   printf ("newline_anchor: %d\n", bufp->newline_anchor);
@@ -969,30 +1083,33 @@
   printf ("not_eol: %d\t", bufp->not_eol);
   printf ("syntax: %d\n", bufp->syntax);
   /* Perhaps we should print the translate table?  */
-  /* and maybe the category table? */
 }
 
 
-static void
-print_double_string (re_char *where, re_char *string1, int size1,
-		     re_char *string2, int size2)
+void
+print_double_string (where, string1, size1, string2, size2)
+    const char *where;
+    const char *string1;
+    const char *string2;
+    int size1;
+    int size2;
 {
+  unsigned this_char;
+
   if (where == NULL)
     printf ("(null)");
   else
     {
-      unsigned int this_char;
-
       if (FIRST_STRING_P (where))
-        {
-          for (this_char = where - string1; this_char < size1; this_char++)
-            putchar (string1[this_char]);
+	{
+	  for (this_char = where - string1; this_char < size1; this_char++)
+	    putchar (string1[this_char]);
 
-          where = string2;
-        }
+	  where = string2;
+	}
 
       for (this_char = where - string2; this_char < size2; this_char++)
-        putchar (string2[this_char]);
+	putchar (string2[this_char]);
     }
 }
 
@@ -1009,7 +1126,7 @@
 #define DEBUG_PRINT_COMPILED_PATTERN(p, s, e)
 #define DEBUG_PRINT_DOUBLE_STRING(w, s1, sz1, s2, sz2)
 
-#endif /* DEBUG */
+#endif /* not DEBUG */
 
 /* Set by `re_set_syntax' to the current regexp syntax to recognize.  Can
    also be assigned to arbitrarily: each pattern buffer stores its own
@@ -1024,10 +1141,11 @@
    different, incompatible syntaxes.
 
    The argument SYNTAX is a bit mask comprised of the various bits
-   defined in regex.h.  We return the old syntax.  */
+   defined in regex.h.	We return the old syntax.  */
 
 reg_syntax_t
-re_set_syntax (reg_syntax_t syntax)
+re_set_syntax (syntax)
+    reg_syntax_t syntax;
 {
   reg_syntax_t ret = re_syntax_options;
 
@@ -1036,39 +1154,32 @@
 }
 
 /* This table gives an error message for each of the error codes listed
-   in regex.h.  Obviously the order here has to be same as there.
+   in regex.h.	Obviously the order here has to be same as there.
    POSIX doesn't require that we do anything for REG_NOERROR,
-   but why not be nice?  */
+   but why not be nice?	 */
 
 static const char *re_error_msgid[] =
-{
-  "Success",					/* REG_NOERROR */
-  "No match",					/* REG_NOMATCH */
-  "Invalid regular expression",			/* REG_BADPAT */
-  "Invalid collation character",		/* REG_ECOLLATE */
-  "Invalid character class name",		/* REG_ECTYPE */
-  "Trailing backslash",				/* REG_EESCAPE */
-  "Invalid back reference",			/* REG_ESUBREG */
-  "Unmatched [ or [^",				/* REG_EBRACK */
-  "Unmatched ( or \\(",				/* REG_EPAREN */
-  "Unmatched \\{",				/* REG_EBRACE */
-  "Invalid content of \\{\\}",			/* REG_BADBR */
-  "Invalid range end",				/* REG_ERANGE */
-  "Memory exhausted",				/* REG_ESPACE */
-  "Invalid preceding regular expression",	/* REG_BADRPT */
-  "Premature end of regular expression",	/* REG_EEND */
-  "Regular expression too big",			/* REG_ESIZE */
-  "Unmatched ) or \\)",				/* REG_ERPAREN */
-#ifdef emacs
-  "Invalid syntax designator",			/* REG_ESYNTAX */
-#endif
-#ifdef MULE
-  "Ranges may not span charsets",		/* REG_ERANGESPAN */
-  "Invalid category designator",		/* REG_ECATEGORY */
-#endif
-};
+  {
+    gettext_noop ("Success"),	/* REG_NOERROR */
+    gettext_noop ("No match"),	/* REG_NOMATCH */
+    gettext_noop ("Invalid regular expression"), /* REG_BADPAT */
+    gettext_noop ("Invalid collation character"), /* REG_ECOLLATE */
+    gettext_noop ("Invalid character class name"), /* REG_ECTYPE */
+    gettext_noop ("Trailing backslash"), /* REG_EESCAPE */
+    gettext_noop ("Invalid back reference"), /* REG_ESUBREG */
+    gettext_noop ("Unmatched [ or [^"),	/* REG_EBRACK */
+    gettext_noop ("Unmatched ( or \\("), /* REG_EPAREN */
+    gettext_noop ("Unmatched \\{"), /* REG_EBRACE */
+    gettext_noop ("Invalid content of \\{\\}"), /* REG_BADBR */
+    gettext_noop ("Invalid range end"),	/* REG_ERANGE */
+    gettext_noop ("Memory exhausted"), /* REG_ESPACE */
+    gettext_noop ("Invalid preceding regular expression"), /* REG_BADRPT */
+    gettext_noop ("Premature end of regular expression"), /* REG_EEND */
+    gettext_noop ("Regular expression too big"), /* REG_ESIZE */
+    gettext_noop ("Unmatched ) or \\)"), /* REG_ERPAREN */
+  };
 
-/* Avoiding alloca during matching, to placate r_alloc.  */
+/* Avoiding alloca during matching, to placate r_alloc.	 */
 
 /* Define MATCH_MAY_ALLOCATE unless we need to make sure that the
    searching and matching functions should not call alloca.  On some
@@ -1100,7 +1211,7 @@
    and (2) it's not safe for them to use malloc.
    Note that if REL_ALLOC is defined, matching would not use malloc for the
    failure stack, but we would still use it for the register vectors;
-   so REL_ALLOC should not affect this.  */
+   so REL_ALLOC should not affect this.	 */
 #if (defined (C_ALLOCA) || defined (REGEX_MALLOC)) && defined (emacs)
 #undef MATCH_MAY_ALLOCATE
 #endif
@@ -1111,28 +1222,30 @@
    REGEX_ALLOCATE_STACK.  */
 
 
-/* Number of failure points for which to initially allocate space
+/* Approximate number of failure points for which to initially allocate space
    when matching.  If this number is exceeded, we allocate more
    space, so it is not a hard limit.  */
 #ifndef INIT_FAILURE_ALLOC
-#define INIT_FAILURE_ALLOC 5
+#define INIT_FAILURE_ALLOC 20
 #endif
 
 /* Roughly the maximum number of failure points on the stack.  Would be
-   exactly that if always used MAX_FAILURE_SPACE each time we failed.
+   exactly that if always used TYPICAL_FAILURE_SIZE items each time we failed.
    This is a variable only so users of regex can assign to it; we never
-   change it ourselves.  */
+   change it ourselves.	 */
 #if defined (MATCH_MAY_ALLOCATE)
-/* 4400 was enough to cause a crash on Alpha OSF/1,
-   whose default stack limit is 2mb.  */
-int re_max_failures = 20000;
+/* Note that 4400 is enough to cause a crash on Alpha OSF/1,
+   whose default stack limit is 2mb.  In order for a larger
+   value to work reliably, you have to try to make it accord
+   with the process stack limit.  */
+int re_max_failures = 40000;
 #else
-int re_max_failures = 2000;
+int re_max_failures = 4000;
 #endif
 
 union fail_stack_elt
 {
-  re_char *pointer;
+  unsigned char *pointer;
   int integer;
 };
 
@@ -1141,8 +1254,8 @@
 typedef struct
 {
   fail_stack_elt_t *stack;
-  size_t size;
-  size_t avail;			/* Offset of next open position.  */
+  unsigned size;
+  unsigned avail;			/* Offset of next open position.  */
 } fail_stack_type;
 
 #define FAIL_STACK_EMPTY()     (fail_stack.avail == 0)
@@ -1157,7 +1270,8 @@
 #define INIT_FAIL_STACK()						\
   do {									\
     fail_stack.stack = (fail_stack_elt_t *)				\
-      REGEX_ALLOCATE_STACK (INIT_FAILURE_ALLOC * sizeof (fail_stack_elt_t));	\
+      REGEX_ALLOCATE_STACK (INIT_FAILURE_ALLOC * TYPICAL_FAILURE_SIZE	\
+			    * sizeof (fail_stack_elt_t));		\
 									\
     if (fail_stack.stack == NULL)					\
       return -2;							\
@@ -1177,25 +1291,41 @@
 #endif
 
 
-/* Double the size of FAIL_STACK, up to approximately `re_max_failures' items.
+/* Double the size of FAIL_STACK, up to a limit
+   which allows approximately `re_max_failures' items.
 
    Return 1 if succeeds, and 0 if either ran out of memory
    allocating space for it or it was already too large.
 
-   REGEX_REALLOCATE_STACK requires `destination' be declared.   */
+   REGEX_REALLOCATE_STACK requires `destination' be declared.	*/
 
-#define DOUBLE_FAIL_STACK(fail_stack)					\
-  ((fail_stack).size > re_max_failures * MAX_FAILURE_ITEMS		\
+/* Factor to increase the failure stack size by
+   when we increase it.
+   This used to be 2, but 2 was too wasteful
+   because the old discarded stacks added up to as much space
+   were as ultimate, maximum-size stack.  */
+#define FAIL_STACK_GROWTH_FACTOR 4
+
+#define GROW_FAIL_STACK(fail_stack)					\
+  (((fail_stack).size * sizeof (fail_stack_elt_t)			\
+    >= re_max_failures * TYPICAL_FAILURE_SIZE)				\
    ? 0									\
-   : ((fail_stack).stack = (fail_stack_elt_t *)				\
-        REGEX_REALLOCATE_STACK ((fail_stack).stack, 			\
-          (fail_stack).size * sizeof (fail_stack_elt_t),		\
-          ((fail_stack).size << 1) * sizeof (fail_stack_elt_t)),	\
+   : ((fail_stack).stack						\
+      = (fail_stack_elt_t *)						\
+	REGEX_REALLOCATE_STACK ((fail_stack).stack,			\
+	  (fail_stack).size * sizeof (fail_stack_elt_t),		\
+	  MIN (re_max_failures * TYPICAL_FAILURE_SIZE,			\
+	       ((fail_stack).size * sizeof (fail_stack_elt_t)		\
+		* FAIL_STACK_GROWTH_FACTOR))),				\
 									\
       (fail_stack).stack == NULL					\
       ? 0								\
-      : ((fail_stack).size <<= 1, 					\
-         1)))
+      : ((fail_stack).size						\
+	 = (MIN (re_max_failures * TYPICAL_FAILURE_SIZE,		\
+		 ((fail_stack).size * sizeof (fail_stack_elt_t)		\
+		  * FAIL_STACK_GROWTH_FACTOR))				\
+	    / sizeof (fail_stack_elt_t)),				\
+	 1)))
 
 
 /* Push pointer POINTER on FAIL_STACK.
@@ -1203,26 +1333,26 @@
    space to do so.  */
 #define PUSH_PATTERN_OP(POINTER, FAIL_STACK)				\
   ((FAIL_STACK_FULL ()							\
-    && !DOUBLE_FAIL_STACK (FAIL_STACK))					\
+    && !GROW_FAIL_STACK (FAIL_STACK))					\
    ? 0									\
    : ((FAIL_STACK).stack[(FAIL_STACK).avail++].pointer = POINTER,	\
       1))
 
 /* Push a pointer value onto the failure stack.
    Assumes the variable `fail_stack'.  Probably should only
-   be called from within `PUSH_FAILURE_POINT'.  */
+   be called from within `PUSH_FAILURE_POINT'.	*/
 #define PUSH_FAILURE_POINTER(item)					\
   fail_stack.stack[fail_stack.avail++].pointer = (unsigned char *) (item)
 
 /* This pushes an integer-valued item onto the failure stack.
    Assumes the variable `fail_stack'.  Probably should only
-   be called from within `PUSH_FAILURE_POINT'.  */
+   be called from within `PUSH_FAILURE_POINT'.	*/
 #define PUSH_FAILURE_INT(item)					\
   fail_stack.stack[fail_stack.avail++].integer = (item)
 
 /* Push a fail_stack_elt_t value onto the failure stack.
    Assumes the variable `fail_stack'.  Probably should only
-   be called from within `PUSH_FAILURE_POINT'.  */
+   be called from within `PUSH_FAILURE_POINT'.	*/
 #define PUSH_FAILURE_ELT(item)					\
   fail_stack.stack[fail_stack.avail++] =  (item)
 
@@ -1246,71 +1376,65 @@
    if we ever fail back to it.
 
    Requires variables fail_stack, regstart, regend, reg_info, and
-   num_regs be declared.  DOUBLE_FAIL_STACK requires `destination' be
+   num_regs be declared.  GROW_FAIL_STACK requires `destination' be
    declared.
 
    Does `return FAILURE_CODE' if runs out of memory.  */
 
-#if !defined (REGEX_MALLOC) && !defined (REL_ALLOC)
-#define DECLARE_DESTINATION char *destination;
-#else
-#define DECLARE_DESTINATION
-#endif
-
 #define PUSH_FAILURE_POINT(pattern_place, string_place, failure_code)	\
   do {									\
-    DECLARE_DESTINATION							\
+    char *destination;							\
     /* Must be int, so when we don't save any registers, the arithmetic	\
        of 0 + -1 isn't done as unsigned.  */				\
     int this_reg;							\
-    									\
+									\
     DEBUG_STATEMENT (failure_id++);					\
     DEBUG_STATEMENT (nfailure_points_pushed++);				\
     DEBUG_PRINT2 ("\nPUSH_FAILURE_POINT #%u:\n", failure_id);		\
     DEBUG_PRINT2 ("  Before push, next avail: %d\n", (fail_stack).avail);\
-    DEBUG_PRINT2 ("                     size: %d\n", (fail_stack).size);\
+    DEBUG_PRINT2 ("			size: %d\n", (fail_stack).size);\
 									\
     DEBUG_PRINT2 ("  slots needed: %d\n", NUM_FAILURE_ITEMS);		\
-    DEBUG_PRINT2 ("     available: %d\n", REMAINING_AVAIL_SLOTS);	\
+    DEBUG_PRINT2 ("	available: %d\n", REMAINING_AVAIL_SLOTS);	\
 									\
     /* Ensure we have enough space allocated for what we will push.  */	\
     while (REMAINING_AVAIL_SLOTS < NUM_FAILURE_ITEMS)			\
       {									\
-        if (!DOUBLE_FAIL_STACK (fail_stack))				\
-          return failure_code;						\
+	if (!GROW_FAIL_STACK (fail_stack))				\
+	  return failure_code;						\
 									\
-        DEBUG_PRINT2 ("\n  Doubled stack; size now: %d\n",		\
+	DEBUG_PRINT2 ("\n  Doubled stack; size now: %d\n",		\
 		       (fail_stack).size);				\
-        DEBUG_PRINT2 ("  slots available: %d\n", REMAINING_AVAIL_SLOTS);\
+	DEBUG_PRINT2 ("	 slots available: %d\n", REMAINING_AVAIL_SLOTS);\
       }									\
 									\
     /* Push the info, starting with the registers.  */			\
     DEBUG_PRINT1 ("\n");						\
 									\
-    for (this_reg = lowest_active_reg; this_reg <= highest_active_reg;	\
-         this_reg++)							\
-      {									\
-	DEBUG_PRINT2 ("  Pushing reg: %d\n", this_reg);			\
-        DEBUG_STATEMENT (num_regs_pushed++);				\
+    if (1)								\
+      for (this_reg = lowest_active_reg; this_reg <= highest_active_reg; \
+	   this_reg++)							\
+	{								\
+	  DEBUG_PRINT2 ("  Pushing reg: %d\n", this_reg);		\
+	  DEBUG_STATEMENT (num_regs_pushed++);				\
 									\
-	DEBUG_PRINT2 ("    start: 0x%lx\n", (long) regstart[this_reg]);	\
-        PUSH_FAILURE_POINTER (regstart[this_reg]);			\
-                                                                        \
-	DEBUG_PRINT2 ("    end: 0x%lx\n", (long) regend[this_reg]);	\
-        PUSH_FAILURE_POINTER (regend[this_reg]);			\
+	  DEBUG_PRINT2 ("    start: 0x%x\n", regstart[this_reg]);	\
+	  PUSH_FAILURE_POINTER (regstart[this_reg]);			\
 									\
-	DEBUG_PRINT2 ("    info: 0x%lx\n      ",			\
-		      * (long *) (&reg_info[this_reg]));		\
-        DEBUG_PRINT2 (" match_null=%d",					\
-                      REG_MATCH_NULL_STRING_P (reg_info[this_reg]));	\
-        DEBUG_PRINT2 (" active=%d", IS_ACTIVE (reg_info[this_reg]));	\
-        DEBUG_PRINT2 (" matched_something=%d",				\
-                      MATCHED_SOMETHING (reg_info[this_reg]));		\
-        DEBUG_PRINT2 (" ever_matched=%d",				\
-                      EVER_MATCHED_SOMETHING (reg_info[this_reg]));	\
-	DEBUG_PRINT1 ("\n");						\
-        PUSH_FAILURE_ELT (reg_info[this_reg].word);			\
-      }									\
+	  DEBUG_PRINT2 ("    end: 0x%x\n", regend[this_reg]);		\
+	  PUSH_FAILURE_POINTER (regend[this_reg]);			\
+									\
+	  DEBUG_PRINT2 ("    info: 0x%x\n      ", reg_info[this_reg]);	\
+	  DEBUG_PRINT2 (" match_null=%d",				\
+			REG_MATCH_NULL_STRING_P (reg_info[this_reg]));	\
+	  DEBUG_PRINT2 (" active=%d", IS_ACTIVE (reg_info[this_reg]));	\
+	  DEBUG_PRINT2 (" matched_something=%d",			\
+			MATCHED_SOMETHING (reg_info[this_reg]));	\
+	  DEBUG_PRINT2 (" ever_matched=%d",				\
+			EVER_MATCHED_SOMETHING (reg_info[this_reg]));	\
+	  DEBUG_PRINT1 ("\n");						\
+	  PUSH_FAILURE_ELT (reg_info[this_reg].word);			\
+	}								\
 									\
     DEBUG_PRINT2 ("  Pushing  low active reg: %d\n", lowest_active_reg);\
     PUSH_FAILURE_INT (lowest_active_reg);				\
@@ -1318,12 +1442,12 @@
     DEBUG_PRINT2 ("  Pushing high active reg: %d\n", highest_active_reg);\
     PUSH_FAILURE_INT (highest_active_reg);				\
 									\
-    DEBUG_PRINT2 ("  Pushing pattern 0x%lx: \n", (long) pattern_place);	\
+    DEBUG_PRINT2 ("  Pushing pattern 0x%x: ", pattern_place);		\
     DEBUG_PRINT_COMPILED_PATTERN (bufp, pattern_place, pend);		\
     PUSH_FAILURE_POINTER (pattern_place);				\
 									\
-    DEBUG_PRINT2 ("  Pushing string 0x%lx: `", (long) string_place);	\
-    DEBUG_PRINT_DOUBLE_STRING (string_place, string1, size1, string2,   \
+    DEBUG_PRINT2 ("  Pushing string 0x%x: `", string_place);		\
+    DEBUG_PRINT_DOUBLE_STRING (string_place, string1, size1, string2,	\
 				 size2);				\
     DEBUG_PRINT1 ("'\n");						\
     PUSH_FAILURE_POINTER (string_place);				\
@@ -1343,16 +1467,19 @@
 #define NUM_NONREG_ITEMS 4
 #endif
 
-/* We push at most this many items on the stack.  */
-/* We used to use (num_regs - 1), which is the number of registers
-   this regexp will save; but that was changed to 5
-   to avoid stack overflow for a regexp with lots of parens.  */
-#define MAX_FAILURE_ITEMS (5 * NUM_REG_ITEMS + NUM_NONREG_ITEMS)
-
-/* We actually push this many items.  */
-#define NUM_FAILURE_ITEMS						\
-  ((highest_active_reg - lowest_active_reg + 1) * NUM_REG_ITEMS 	\
-    + NUM_NONREG_ITEMS)
+/* Estimate the size of data pushed by a typical failure stack entry.
+   An estimate is all we need, because all we use this for
+   is to choose a limit for how big to make the failure stack.  */
+
+#define TYPICAL_FAILURE_SIZE 20
+
+/* This is how many items we actually use for a failure point.
+   It depends on the regexp.  */
+#define NUM_FAILURE_ITEMS				\
+  (((0							\
+     ? 0 : highest_active_reg - lowest_active_reg + 1)	\
+    * NUM_REG_ITEMS)					\
+   + NUM_NONREG_ITEMS)
 
 /* How many items can still be added to the stack without overflowing it.  */
 #define REMAINING_AVAIL_SLOTS ((fail_stack).size - (fail_stack).avail)
@@ -1368,11 +1495,11 @@
      REG_INFO -- array of information about each subexpression.
 
    Also assumes the variables `fail_stack' and (if debugging), `bufp',
-   `pend', `string1', `size1', `string2', and `size2'.  */
+   `pend', `string1', `size1', `string2', and `size2'.	*/
 
 #define POP_FAILURE_POINT(str, pat, low_reg, high_reg, regstart, regend, reg_info)\
 {									\
-  DEBUG_STATEMENT (fail_stack_elt_t ffailure_id;)			\
+  DEBUG_STATEMENT (fail_stack_elt_t failure_id;)			\
   int this_reg;								\
   const unsigned char *string_temp;					\
 									\
@@ -1381,27 +1508,26 @@
   /* Remove failure points and point to how many regs pushed.  */	\
   DEBUG_PRINT1 ("POP_FAILURE_POINT:\n");				\
   DEBUG_PRINT2 ("  Before pop, next avail: %d\n", fail_stack.avail);	\
-  DEBUG_PRINT2 ("                    size: %d\n", fail_stack.size);	\
+  DEBUG_PRINT2 ("		     size: %d\n", fail_stack.size);	\
 									\
   assert (fail_stack.avail >= NUM_NONREG_ITEMS);			\
 									\
-  DEBUG_POP (&ffailure_id.integer);					\
-  DEBUG_PRINT2 ("  Popping failure id: %u\n",				\
-		* (unsigned int *) &ffailure_id);			\
+  DEBUG_POP (&failure_id.integer);					\
+  DEBUG_PRINT2 ("  Popping failure id: %u\n", failure_id.integer);	\
 									\
   /* If the saved string location is NULL, it came from an		\
      on_failure_keep_string_jump opcode, and we want to throw away the	\
      saved NULL, thus retaining our current position in the string.  */	\
   string_temp = POP_FAILURE_POINTER ();					\
   if (string_temp != NULL)						\
-    str = string_temp;							\
+    str = (const char *) string_temp;					\
 									\
-  DEBUG_PRINT2 ("  Popping string 0x%lx: `",  (long) str);		\
+  DEBUG_PRINT2 ("  Popping string 0x%x: `", str);			\
   DEBUG_PRINT_DOUBLE_STRING (str, string1, size1, string2, size2);	\
   DEBUG_PRINT1 ("'\n");							\
 									\
   pat = (unsigned char *) POP_FAILURE_POINTER ();			\
-  DEBUG_PRINT2 ("  Popping pattern 0x%lx: ", (long) pat);		\
+  DEBUG_PRINT2 ("  Popping pattern 0x%x: ", pat);			\
   DEBUG_PRINT_COMPILED_PATTERN (bufp, pat, pend);			\
 									\
   /* Restore register info.  */						\
@@ -1411,19 +1537,29 @@
   low_reg = (unsigned) POP_FAILURE_INT ();				\
   DEBUG_PRINT2 ("  Popping  low active reg: %d\n", low_reg);		\
 									\
-  for (this_reg = high_reg; this_reg >= low_reg; this_reg--)		\
-    {									\
-      DEBUG_PRINT2 ("    Popping reg: %d\n", this_reg);			\
+  if (1)								\
+    for (this_reg = high_reg; this_reg >= low_reg; this_reg--)		\
+      {									\
+	DEBUG_PRINT2 ("	   Popping reg: %d\n", this_reg);		\
 									\
-      reg_info[this_reg].word = POP_FAILURE_ELT ();			\
-      DEBUG_PRINT2 ("      info: 0x%lx\n",				\
-		    * (long *) &reg_info[this_reg]);			\
+	reg_info[this_reg].word = POP_FAILURE_ELT ();			\
+	DEBUG_PRINT2 ("	     info: 0x%x\n", reg_info[this_reg]);	\
 									\
-      regend[this_reg] = POP_FAILURE_POINTER ();			\
-      DEBUG_PRINT2 ("      end: 0x%lx\n", (long) regend[this_reg]);	\
+	regend[this_reg] = (const char *) POP_FAILURE_POINTER ();	\
+	DEBUG_PRINT2 ("	     end: 0x%x\n", regend[this_reg]);		\
 									\
-      regstart[this_reg] = POP_FAILURE_POINTER ();			\
-      DEBUG_PRINT2 ("      start: 0x%lx\n", (long) regstart[this_reg]);	\
+	regstart[this_reg] = (const char *) POP_FAILURE_POINTER ();	\
+	DEBUG_PRINT2 ("	     start: 0x%x\n", regstart[this_reg]);	\
+      }									\
+  else									\
+    {									\
+      for (this_reg = highest_active_reg; this_reg > high_reg; this_reg--) \
+	{								\
+	  reg_info[this_reg].word.integer = 0;				\
+	  regend[this_reg] = 0;						\
+	  regstart[this_reg] = 0;					\
+	}								\
+      highest_active_reg = high_reg;					\
     }									\
 									\
   set_regs_matched_done = 0;						\
@@ -1449,7 +1585,7 @@
   struct
   {
       /* This field is one if this group can match the empty string,
-         zero if not.  If not yet determined,  `MATCH_NULL_UNSET_VALUE'.  */
+	 zero if not.  If not yet determined,  `MATCH_NULL_UNSET_VALUE'.  */
 #define MATCH_NULL_UNSET_VALUE 3
     unsigned match_null_string_p : 2;
     unsigned is_active : 1;
